/*
Gestione di un sensore ultrasuoni
Parte del corso di robotica CodemotionKids 2015 
http://www.codemotionkids.com/

Autore: Paolo De Gasperis
paolo@discienza.org


*/

// specifica i pin di trig e echo usati per il sensore ad ultrasuoni
const int TrigPin = 8; // allaccio sul pin 8 della Arduino il pin che attiva lo sparo del sensore ultrasuoni
const int EchoPin = 9; // allaccio al pin 9 della Arduino il pin che legge il rilevatore del segnale ultrasuoni inviato
unsigned int distanza; // distanza rilevata dal sensore unsigned significa che non avrà mai valori negativi. 
                       //Il sensore a volte ci resitutisce valori negativi quando non ha nulla davanti
int durata;            // durata del segnale di ritorno rilevato dal sensore a ultrasuoni


void setup()
{
  Serial.begin(9600);     // Inizializza la comunicazione con la seriale a 9600 bit per secondo
  pinMode(TrigPin, OUTPUT);  // Il pin allacciato al Trig del sensore spara il segnale quindi è un OUTPUT
  pinMode(EchoPin, INPUT);   // Il pin allacciato al pin Echo del sensore riceve il segnale di ritorno quindi è un INPUT

}


void loop() // il loop è il ciclo di azioni che faranno le componenti
{
  
  {
  digitalWrite(TrigPin, LOW);   // Sparo del segnale spento
  delayMicroseconds(2);          // aspetto 2 microsecondi
  digitalWrite(TrigPin, HIGH);  // accendo lo sparo del segnale, ora il sensore sta inviando ultrasuoni
  delayMicroseconds(10);         // aspetto 10 microsecondi 
  digitalWrite(TrigPin, LOW);  // spengo l'invio di ultrasuoni

  durata = pulseIn(EchoPin, HIGH);  // accendo il rilevatore del sensore e chiedo quando tempo ha impiegato il segnale a tornare
  distanza = (durata/2)/29;         // il valore inviato è la distanza che divido per 2 (andata e ritorno) e poi per 29 che è 
                                  // frutto della conversione della velocità del suono in cm/s diviso per due
  Serial.print("distanza: ");    // faccio scrivere la parola distanza
  Serial.print(distanza);    // mi faccio indicare la distanza
  Serial.print("cm: ");       // faccio scrivere la parola cm
  Serial.println();          // vado una riga sotto
  delay(500); // aspetto 500 millisecondi prima di riniziare
  }
  
}




